<?php

/*
	This is based from on the original code from EQItems by Kyle Smith. 

	Rewritten by Dave Humphrey (uesp@sympatico.ca) merely to become familiar with the
	PHP and item formats (minor changes from original).

	Constants, definitions, and some of the specific item outputs are direct copies from the original.

====== Begin EQItems License======
Copyright (c) 2004-2005, Kyle Smith
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the author nor the names of its contributors may be
      used to endorse or promote products derived from this software without
      specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
====== End EQItems License ======


	TODO:
		- Constants for types
*/

include("common.inc");
include("item_fields.inc");
include("eqfuncs.inc");
include("eqspell.php");

function getItemFields() {
	global $item_fields, $ext_item_fields;
	$fields = "";

	$fields = implode(", ", $item_fields);

/*	foreach ($ext_item_fields as $key => $value) {
		$fields .= ", ". $key. " as ". $value;
	} */

	return $fields;
}

function loadEqItem($id) {

	if ($id == null || $id == "") return null;
	$query = "SELECT ". getItemFields() ." FROM eqitems WHERE (id=".$id.");";

	$result = mysql_query($query);
	if (!$result) return null;

	$row = mysql_fetch_row($result);
	if (count($row) <= 1) return null;

	$item = new EqItem;
	$item->fromArray($row);
	return $item;
}

function strTextLength($text) {
	$temp = $text;
	preg_replace("/<[^>]*>/", "", $temp);
	return strlen($temp);
}

function hasAnchor($text) {
	return preg_match("/<a[^>]*>/", $text) > 0;
}

function wrapLine ($line, $maxlength, $lf) {

	if (hasAnchor($line)) return $line . "\n";	

	$linelength = strlen($line);
	if ($linelength <= $maxlength) return $line . "\n";

	$result = "";
	$i = $maxlength;

	while ($i > 0 && $line[$i] != ' ') {
		$i--;
	}

	if ($i > 0) {
		$result .= substr($line, 0, $i) . $lf;
		$line = substr($line, $i + 1);
		$result .= wrapLine($line, $maxlength, $lf);
	}
	else {
		$result .= $line . "\n";
	}			

	return $result;
}

function wrapHtmlText($text, $maxlength, $lf) {
	$result = "";

	$lines = explode("\n", $text);

	for ($c = 0; $c < count($lines); $c++) {
		$line = $lines[$c];
		$result .= wrapLine($line, $maxlength, $lf);
 	}

	return $result;
}

function formatPrice($price) {
		if ($price == null || $price == 0) return "0 cp";

		$pp    = intval($price / 1000);
		$gp    = intval($price / 100) % 10;
		$sp    = intval($price / 10) % 10;
		$cp    = intval($price) % 10;

		$result = "";
		if ($pp > 0) $result .= $pp . "pp ";
		if ($gp > 0) $result .= $gp . "gp ";
		if ($sp > 0) $result .= $sp . "sp ";
		if ($cp > 0) $result .= $cp . "cp ";

		return $result;
	}


class EqItem {

	var $DATA_SIZE = 180;
	var $VALID_DATA = true;

	var $m_data      = array();
	var $m_isset     = false;
	var $m_spellsset = false;
	var $m_NoHtml    = false;

		/* Spell effects */
	var $m_effect = null;
	var $m_worn   = null;
	var $m_focus  = null;
	var $m_proc   = null;
	var $m_scroll = null;

		/* Constructor */
	function EqItem () {
	}

		/* Initialize the spell objects */
	function initSpells () {
		if ($this->spellsset) return;

		$clickeffect  = $this->getField("clickeffect");
		$focuseffect  = $this->getField("focuseffect");
		$proceffect   = $this->getField("proceffect");
		$scrolleffect = $this->getField("scrolleffect");
		$worneffect   = $this->getField("worneffect");
	
		$this->m_effect = loadEqSpell($clickeffect);
		$this->m_focus  = loadEqSpell($focuseffect);
		$this->m_proc   = loadEqSpell($proceffect);
		$this->m_scroll = loadEqSpell($scrolleffect);
		$this->m_worn   = loadEqSpell($worneffect);

		$this->spellsset = true;
	}

		/* Loads the item data from an array */
	function fromArray ($fields) {
		global $item_fields, $ext_item_fields;

		if (count($fields) < $this->DATA_SIZE) {
			die("Error: item has ". count($fields) ." fields");
			$this->VALID_DATA = false;
		}

		for ($i = 0; $i < $this->DATA_SIZE; $i++) {
			$this->m_data[$item_fields[$i]] = $fields[$i];	
		}

/*		foreach ($ext_item_fields as $key => $value) {
			$this->m_data[$value] = $fields[$i];	
			$i++; 
		} */

		$this->m_isset = true;

		$this->initSpells();
	}
	

		/* Access an item field */
	function getField ($field) {
		if (isset($this->m_data[$field])) {
			return $this->m_data[$field];
		}
		else {
			return 0;
		}
	}

	function getHtmlDisplayString () {
		return $this->getDisplayString("<br />\n");
	}

	function getShortDisplayString ($lf = "\n") {
		$result = "";

		if ($this->isEvolving()) {
			$result .= "Evolving: ". $this->getEvolvingText() . $lf;
		}

			/* Augment */
		if ($this->isAugment()) {
			$result .= $this->getShortAugmentText($lf);
		}
			/* Spell scroll */
		else if ($this->isSpellScroll()) {
			$result .= $this->getShortSpellScrollText($lf);
		}
			/* TBS Powersource */
		else if ($this->isPowerSource()) {
			$result .= $this->getShortPowerSourceText($lf);
		}
			/* All other items */
		else {
			$result .= $this->getShortRegularItemText($lf);
		}

		return $result;
	}

		/* Access an HTML string to display the item */
	function getDisplayString ($lf = "\n") {
		$result = "";

			/* Flags */
		$temp = $this->getFlagText();
		if ($temp != "") $result .= $temp . $lf;

			/* Lore group */
		if ($this->hasLoreGroup()) {
			$result .= "Lore Group: ". $this->getLoreGroupText() . $lf;
		}
		else if ($this->isEvolving()) {
			$result .= "Evolving: ". $this->getEvolvingText() . $lf;
		}

			/* Augment */
		if ($this->isAugment()) {
			$result .= $this->getAugmentText($lf);
		}
			/* Spell scroll */
		else if ($this->isSpellScroll()) {
			$result .= $this->getSpellScrollText($lf);
		}
			/* TBS Powersource */
		else if ($this->isPowerSource()) {
			$result .= $this->getPowerSourceText($lf);
		}
			/* All other items */
		else {
			$result .= $this->getRegularItemText($lf);
		}

		return $result;
	}

	function getAugmentText ($lf = "\n") {
		$result = "";
	
		$result .= "Augmentation Type: ". $this->getAugType() . $lf;
		$result .= "WT: ". $this->getWeight() ." Size: ". $this->getSize() . $lf;

		$result .= $this->formatStatString("DMG: ", $this->getDamage(), $lf);
		$result .= $this->formatStatString("AC: ", $this->getAC(), $lf);
		$result .= $this->formatStatString($this->getElementalType() ." DMG: ", $this->getElementalDmg(), $lf);
		$result .= $this->formatStatString("Bane DMG: ". $this->getBaneType() ." +",  $this->getBaneDmg(), $lf);

		if ($this->hasSkillMod()) $result .= "Skill Mod: ". $this->getSkillModType() ." +". $this->getSkillModValue() . "%" .$lf;

		$temp = $this->getEffectText($lf);
		if ($temp != "") $result .= "Effect: ". $temp . $lf;
		$temp = $this->getProcText();
		if ($temp != "")   $result .= "Effect: ". $temp . $lf;
		$temp = $this->getWornText();
		if ($temp != "")   $result .= "Effect: ". $temp . $lf;
		$temp = $this->getFocusText();
		if ($temp != "")  $result .= "Focus Effect: ". $temp . $lf;

		$temp = $this->getStatText();
		if ($temp != "") $result .=  $temp . $lf;

		$temp = $this->getResistText();
		if ($temp != "") $result .= $temp . $lf;

		if ($this->isInstrument()) $result .= $this->getBardText() . $lf;

		//$result .= $this->formatStatString("Attack: ", $this->getAttack(), $lf);
		//$result .= $this->formatStatString("Regeneration: ", $this->getRegen(), $lf);
		//$result .= $this->formatStatString("Mana Regeneration: ", $this->getManaRegen(), $lf);
		//$result .= $this->formatStatString("Endurance Regeneration: ", $this->getEnduranceRegen(), $lf);
		//$result .= $this->formatStatString("Haste: ", $this->getHaste(), "%".$lf);
		//$result .= $this->formatStatString("Damage Shield: ", $this->getDamageShield(), $lf);

		$temp = $this->getModsText();
		if ($temp != "") $result .= $temp . $lf;

		//$result .= $this->formatStatString("DoT Shielding: ", $this->getDotShielding(), "%".$lf);
		$result .= $this->formatStatString($this->getExtraDmgSkill() . " DMG: ", $this->getExtraDmgAmt(), $lf);

		$result .= $lf . "Restrictions -".$lf;

		$temp = $this->getAugRestriction();
		if ($temp != "") $result .= $temp .$lf;

		$result .= $this->formatStatString("Min Delay: ", $this->getDelay(), $lf);
		if ($this->hasSlots()) $result .= "Slot: " . $this->getSlotText() . $lf;

		$result .= $this->formatStatStringPos("Recommended level of ", $this->getRecommendedLevel(), $lf);
		$result .= $this->formatStatStringPos("Required level of ", $this->getRequiredLevel(), $lf);

		if ($this->hasRecommendedSkill()) {
			$skillname = $this->getItemType();
			if ($skillname == "Armor") $skillname = "Defense";
			$result .= "Recommended skill of ". $this->getRecommendedSkill() ." ". $skillname . "." . $lf;
		}

		$temp = $this->getClassText();
		if ($temp != "") $result .= "Class: " . $temp . $lf;

		$temp = $this->getRaceText();
		if ($this->getRaces()   > 0) $result .= "Race: "  . $temp . $lf;

		$temp = $this->getDeityText();
		if ($this->getDeities() > 0) $result .= "Diety: " . $temp . $lf;

		$temp = $this->getAugSolvent();

		if ($temp != "0") {
			$result .= $lf;
			$result .= "Item Information:" . $lf;
			$result .= "You must use the solvent ". $temp . " to remove this augment safely." . $lf;
		}

		$result .= $this->getEffectDescText($lf);

		return $result;
	}

	function getShortAugmentText ($lf = "\n") {
		$result = "";
	
		$result .= "Aug Type: ". $this->getAugType() . $lf;

		$result .= $this->formatStatString("DMG: ", $this->getDamage(), $lf);
		$result .= $this->formatStatString("AC: ", $this->getAC(), $lf);
		$result .= $this->formatStatString($this->getElementalType() ." DMG: ", $this->getElementalDmg(), $lf);
		$result .= $this->formatStatString("Bane DMG: ". $this->getBaneType() ." +",  $this->getBaneDmg(), $lf);

		if ($this->hasSkillMod()) $result .= "". $this->getSkillModType() ." +". $this->getSkillModValue() . "%" .$lf;

		$temp = $this->getStatText();
		if ($temp != "") $result .=  $temp . $lf;

		$temp = $this->getResistText();
		if ($temp != "") $result .= $temp . $lf;

		if ($this->isInstrument()) $result .= $this->getBardText() . $lf;

		//$result .= $this->formatStatString("Attack: ", $this->getAttack(), $lf);
		//$result .= $this->formatStatString("Regeneration: ", $this->getRegen(), $lf);
		//$result .= $this->formatStatString("Mana Regeneration: ", $this->getManaRegen(), $lf);
		//$result .= $this->formatStatString("Endurance Regeneration: ", $this->getEnduranceRegen(), $lf);
		//$result .= $this->formatStatString("Haste: ", $this->getHaste(), "%".$lf);
		//$result .= $this->formatStatString("Damage Shield: ", $this->getDamageShield(), $lf);

		$temp = $this->getModsText();
		if ($temp != "") $result .= $temp . $lf;

		//$result .= $this->formatStatString("DoT Shielding: ", $this->getDotShielding(), "%".$lf);
		$result .= $this->formatStatString($this->getExtraDmgSkill() . " DMG: ", $this->getExtraDmgAmt(), $lf);

		return $result;
	}

	function getPowerSourceText ($lf = "\n") {
		$result = "";

		$result .= "Solt: " . $this->getSlotText() . $lf;
		$result .= "Power: ". $this->getPowerSourceCapacity() . "/" . $this->getPowerSourceCapacity() . $lf;
		$result .= $this->formatStatStringPos("Recommended level of ", $this->getRecommendedLevel(), $lf);
		$result .= $this->formatStatStringPos("Required level of ", $this->getRequiredLevel(), $lf);

		$result .= "WT: ". $this->getWeight() ." ";
		$result .= "Size: " . $this->getSize() . $lf;

		$temp = $this->getClassText();
		if ($temp != "") $result .= "Class: " . $temp . $lf;

		$temp = $this->getRaceText();
		if ($this->getRaces()   > 0) $result .= "Race: "  . $temp . $lf;

		$element = $this->getField("charmfile");
		if ($element) $element = substr($element, 3);

		$result .= "Item Information:" . $lf;
		$result .= "Element: ". $element . $lf;

		return $result;
	}

	function getShortPowerSourceText ($lf = "\n") {
		$result = "";
		$result .= "Power: ". $this->getPowerSourceCapacity() . "/" . $this->getPowerSourceCapacity() . $lf;
		return $result;
	}

	function getSpellScrollText ($lf = "\n") {
		$result = "";

		if ($this->hasCharges()) $result .= "Charges: ". $this->getCharges() . $lf;

		$result .= "Level Needed: ". $this->m_scroll->getClasses() . $lf;
		$result .= "Skill: ". $this->m_scroll->getSkillName() . $lf;
		$result .= "Mana Cost: ". $this->m_scroll->getMana() . $lf;

		if ($this->scroll->isDiscipline())
			$result .= "Combat";
		else
			$result .= "Spell";

		$itemstring .= " Effect: ". $this->scroll->getDescription() . $lf;

		$result .= "WT: ". $this->getWeight() ." ";
		$result .= "Size: ". $this->getSize() . $lf;

		$temp = $this->getRaceText();
		if ($this->getRaces()   > 0) $result .= "Race: "  . $temp . $lf;

		$temp = $this->getDeityText();
		if ($this->getDeities() > 0) $result .= "Diety: " . $temp . $lf;

		return $result;
	}

	function getShortSpellScrollText ($lf = "\n") {
		$result = "";

		if ($this->hasCharges()) $result .= "Charges: ". $this->getCharges() . $lf;

		if ($this->scroll->isDiscipline())
			$result .= "Combat";
		else
			$result .= "Spell";

		$itemstring .= " Effect: ". $this->scroll->getDescription() . $lf;

		return $result;
	}


	function getRegularItemText ($lf = "\n") {
		$result = "";

		if ($this->hasSlots()) $result .= "Slot: " . $this->getSlotText() . $lf;

		if ($this->isExpendable()) $result .= "EXPENDABLE ";
		if ($this->hasCharges()) $result .= "Charges: ". $this->getCharges() . $lf;

		if ($this->isPotionBelt()) $result .= "Potion Belt Enabled" . $lf;
		if ($this->isTradeSkill()) $result .= "This item can be used in tradeskills." . $lf;

		if ($this->isWeapon()) {
			$result .= $this->getWeaponText($lf);
		}
		else if ($this->isArrow()) {
			$result .= $this->getArrowText($lf);
		}
		else {
			$purity = $this->getPurity();
			if ($purity > 0) $result .= "Purity: " . $purity . $lf;
		
			$ac = $this->getAC();
			if ($ac > 0) $result .= "AC: " . $ac . $lf;
		}

		if ($this->hasFactionMod()) $result .= "This item has a faction modifier." . $lf;
		if ($this->hasSkillMod())   $result .= "Skill Mod: ". $this->getSkillModType() ." +". $this->getSkillModValue() . "%" .$lf;

		$temp = $this->getEffectText($lf);
		if ($temp != "") $result .= "Effect: ". $temp . $lf;
		$temp = $this->getProcText();
		if ($temp != "")   $result .= "Effect: ". $temp . $lf;
		$temp = $this->getWornText();
		if ($temp != "")   $result .= "Effect: ". $temp . $lf;
		$temp = $this->getFocusText();
		if ($temp != "")  $result .= "Focus Effect: ". $temp . $lf;

		$temp = $this->getStatText();
		if ($temp != "") $result .=  $temp . $lf;

		$temp = $this->getResistText();
		if ($temp != "") $result .= $temp . $lf;

		if ($this->isInstrument()) $result .= $this->getBardText() . $lf;

		//$result .= $this->formatStatString("Attack: ", $this->getAttack(), $lf);
		//$result .= $this->formatStatString("Regeneration: ", $this->getRegen(), $lf);
		//$result .= $this->formatStatString("Mana Regeneration: ", $this->getManaRegen(), $lf);
		//$result .= $this->formatStatString("Endurance Regeneration: ", $this->getEnduranceRegen(), $lf);
		//$result .= $this->formatStatString("Haste: ", $this->getHaste(), "%".$lf);
		//$result .= $this->formatStatString("Damage Shield: ", $this->getDamageShield(), $lf);

		$temp = $this->getModsText();
		if ($temp != "") $result .= $temp . $lf;

		//$result .= $this->formatStatString("DoT Shielding: ", $this->getDotShielding(), "%".$lf);
		$result .= $this->formatStatString($this->getExtraDmgSkill() . " DMG: ", $this->getExtraDmgAmt(), $lf);
		$result .= $this->formatStatStringPos("Recommended level of ", $this->getRecommendedLevel(), $lf);
		$result .= $this->formatStatStringPos("Required level of ", $this->getRequiredLevel(), $lf);

		if ($this->hasRecommendedSkill()) {
			$skillname = $this->getItemType();
			if ($skillname == "Armor") $skillname = "Defense";
			$result .= "Recommended skill of ". $this->getRecommendedSkill() ." ". $skillname . "." . $lf;
		}

		if ($this->isFoodDrink()) $result .= $this->getFoodDrinkText() . $lf;
		$result .= "WT: ". $this->getWeight() ." ";

		if ($this->isContainer()) {
			$result .= $this->getContainerText($lf) . $lf;
		} else {
			$result .= $this->formatStatString("Range ", $this->getRange(), " ");
			$result .= "Size: " . $this->getSize() . $lf;
		}

		$temp = $this->getClassText();
		if ($temp != "") $result .= "Class: " . $temp . $lf;

		$temp = $this->getRaceText();
		if ($this->getRaces()   > 0) $result .= "Race: "  . $temp . $lf;

		$temp = $this->getDeityText();
		if ($this->getDeities() > 0) $result .= "Diety: " . $temp . $lf;
			
		if ($this->hasAugSlot1()) $result .= $this->formatStatStringPos("Slot 1, type ", $this->getAugSlot1Type(), ": empty" . $lf);
		if ($this->hasAugSlot2()) $result .= $this->formatStatStringPos("Slot 2, type ", $this->getAugSlot2Type(), ": empty" . $lf);
		if ($this->hasAugSlot3()) $result .= $this->formatStatStringPos("Slot 3, type ", $this->getAugSlot3Type(), ": empty" . $lf);

		$result .= $this->getEffectDescText($lf);

		return $result . "";
	}

	function getShortRegularItemText ($lf = "\n") {
		$result = "";

		if ($this->isWeapon()) {
			$result .= $this->getShortWeaponText($lf);
		}
		else if ($this->isArrow()) {
			$result .= $this->getArrowText($lf);
		}
		else {
			$purity = $this->getPurity();
			if ($purity > 0) $result .= "Purity: " . $purity . $lf;
		
			$ac = $this->getAC();
			if ($ac > 0) $result .= "AC: " . $ac . $lf;
		}

		if ($this->hasSkillMod()) $result .= "". $this->getSkillModType() ." +". $this->getSkillModValue() . "%" .$lf;

		$temp = $this->getStatText();
		if ($temp != "") $result .=  $temp . $lf;

		$temp = $this->getResistText();
		if ($temp != "") $result .= $temp . $lf;

		if ($this->isInstrument()) $result .= $this->getBardText() . $lf;

		//$result .= $this->formatStatString("Attack: ", $this->getAttack(), $lf);
		//$result .= $this->formatStatString("Regeneration: ", $this->getRegen(), $lf);
		//$result .= $this->formatStatString("Mana Regeneration: ", $this->getManaRegen(), $lf);
		//$result .= $this->formatStatString("Endurance Regeneration: ", $this->getEnduranceRegen(), $lf);
		//$result .= $this->formatStatString("Haste: ", $this->getHaste(), "%".$lf);
		//$result .= $this->formatStatString("Damage Shield: ", $this->getDamageShield(), $lf);

		$temp = $this->getModsText();
		if ($temp != "") $result .= $temp . $lf;

		//$result .= $this->formatStatString("DoT Shielding: ", $this->getDotShielding(), "%".$lf);
		$result .= $this->formatStatString($this->getExtraDmgSkill() . " DMG: ", $this->getExtraDmgAmt(), $lf);

		if ($this->isFoodDrink()) $result .= $this->getFoodDrinkText() . $lf;

		if ($this->isContainer()) {
			$result .= $this->getContainerText($lf) . $lf;
		} else {
			$result .= $this->formatStatString("Range ", $this->getRange(), " ");
		}

		return $result . "";
	}

	function createSpellLink ($spellid, $spellname, $lf = "\n") {
		global $SPELL_URL, $LINK_STYLE;

		if ($this->m_NoHtml) {
			$result = $spellname;
		} else {
			$result = "<a ". $LINK_STYLE . " href='" . $SPELL_URL . "?id=". $spellid . "'>". $spellname ."</a>";
		}
		return $result;
	}

	function getEffectDescText($lf = "\n") {

		$result .= $this->getEffectDescHtmlPriv("click", $this->m_effect, $lf);
		$result .= $this->getEffectDescHtmlPriv("proc", $this->m_proc, $lf);
		$result .= $this->getEffectDescHtmlPriv("worn", $this->m_worn, $lf);

		if ($this->m_focus) {
			$focus_desc = $this->m_focus->getDescription();

			if ($focus_desc != "") {
				$result .= $lf;

				$result .= $this->createSpellLink($this->m_focus->getID(), $this->m_focus->getName(), $lf);
				$result .= $lf;
				$result .= "Focus Effect: ". $focus_desc . $lf;
			}
		}

		return $result;
	}

	function getEffectDescHtmlPriv($value, $spell, $lf = "\n") {
		global $SPELL_URL, $LINK_STYLE;
		$itemstring = "";

		if ($spell && !$this->isSpellScroll()) {
			$effect_desc = $spell->getDescription();
			$effect_name = $spell->getName();
			$effect_level = $this->getField($value ."level");

			if (preg_match("/^(.*) \(.*$/m", $effect_name, $matches)) $effect_name = $matches[1];

			if ($effect_desc != "")	{
				$itemstring .= $lf;
				$itemstring .= $this->createSpellLink($spell->getID(), $effect_name, $lf);
				$itemstring .= $lf;
				if ($effect_level > 0) $itemstring .= "Required Level: ". $effect_level . $lf;
 				$itemstring .= "Spell Effect: ". $effect_desc . $lf;
			}
		}

		return $itemstring;
	}

	function getWeaponText ($lf = "\n") {
		$result = "";

		$purity = $this->getPurity();
		if ($purity > 0) $result .= "Purity: " . $purity . $lf;

		$result .= "Skill: " . $this->getItemType();
		$result .= " Atk Delay: " . $this->getDelay() . $lf;
		$result .= "DMG: " . $this->getDamage() . " ";

		$ac = $this->getAC();
		if ($ac > 0) $result .= "AC: " . $ac;

		$result .= $lf;

		$elemdmg = $this->getElementalDmg();
		if ($elemdmg > 0) $result .= $this->getElementalType() . " DMG: " . $this->getElementalDmg() . $lf;

		return $result;
	}


	function getShortWeaponText ($lf = "\n") {
		$result = "";

		$purity = $this->getPurity();
		if ($purity > 0) $result .= "Purity: " . $purity . $lf;

		$result .= " Atk Delay: " . $this->getDelay() . $lf;
		$result .= "DMG: " . $this->getDamage() . " ";

		$ac = $this->getAC();
		if ($ac > 0) $result .= "AC: " . $ac;

		$result .= $lf;

		$elemdmg = $this->getElementalDmg();
		if ($elemdmg > 0) $result .= $this->getElementalType() . " DMG: " . $this->getElementalDmg() . $lf;

		return $result;
	}

	function getArrowText ($lf = "\n") {
		$result .= "DMG: ". $this->getDamage() . $lf; 
		if ($elemdmg > 0) $result .= $this->getElementalType() ." DMG: ". $this->getElementalDmg() .$lf;
		if ($banedmg > 0) $result .= "Bane DMG: ". $this->getBaneType() ." +". $this->getBaneDmg() . $lf;
		return $result;
	}

	function getContainerText ($lf = "\n") {
		$result = "Weight Reduction: ".$this->getBagWR() . "%" . $lf;
		$result .= "Capacity: ". $this->getBagSlots() ." ";
		$result .= "Size Capacity: ". $this->getBagSize() . $lf;
		return $result;
	}

	function getEffectText ($lf = "\n") {
		global $SPELL_URL, $LINK_STYLE;
		$result = "";

		$clickeffect = $this->getField("clickeffect");
		$clicktype   = $this->getField("clicktype");
		$casttime    = $this->getField("casttime");
		$itemtype    = $this->getField("itemtype");
		$recastdelay = $this->getField("recastdelay");
		$recasttype  = $this->getField("recasttype");

		if ($clickeffect <= 0) return $result;

		$result .= $this->m_effect->getName();
		$result = $this->createSpellLink($clickeffect, $result, $lf);

			# special case for scrolls
		if ($itemtype == 20) return $result;
		$result .= " (";

		if ($casttime <= 0)
			$casttime = "Instant";
		else
			$casttime = sprintf("%2.1f", $casttime / 1000);

		if ($clicktype == 0) {			# combat
			$result .= "Combat";
		} else if ($clicktype == 1) {		# inventory_1 (bards need to stop singing to cast)
			$result .= "Casting Time: $casttime";
		} else if ($clicktype == 2) {		# worn
			$result .= "Worn";
		} else if ($clicktype == 3) {		# inventory_2
			$result .= "Casting Time: $casttime";
		} else if ($clicktype == 4) {		# must equip (bards need to stop singing to cast)
			$result .= "Must Equip.  Casting Time: $casttime";
		} else if ($clicktype == 5) {		# inventory_3
			$result .= "Casting Time: $casttime";
		} else {
			$result .= "Unknown Activation";
		}

		$result .= ")";

		if ($recastdelay > 0) {

				# day, hr, min, sec
			$delays = array();
			$units  = array("day", "hour", "minute", "second");
			$unitsp = array("days", "hours", "minutes", "seconds");
			$used = array();

				# convert delay into text
			$delays[3] = floor($recastdelay % 60); # seconds
			$delays[2] = floor($recastdelay / 60 % 60); # minutes
			$delays[1] = floor($recastdelay / (60 * 60) % 60); # hours
			$delays[0] = floor($recastdelay / (24 * 60 * 60)); # days

			for ($i = 0; $i < 4; $i++)
				if ($delays[$i] > 0)
					$used[] = $delays[$i] ." ". (($delays[$i] == 1) ? $units[$i] : $unitsp[$i]);

			$delay = "";
			$cnt = count($used);

			if ($cnt > 1) {
				for ($i = 0; $i < $cnt - 1; $i++)
					$delay .= $used[$i] .", ";

				$delay .= "and ". $used[$cnt - 1];
			} else {
				$delay = $used[0];
			}

			$result .= $lf;
			$result .= "Recast Delay: ". $delay;

			if ($recasttype > 0) {
				$result .= ", Recast Type: ". $recasttype;
			}
		}

		return $result;
	}

	function getFocusText () {
		$result = "";

		$focuseffect = $this->getField("focuseffect");
		if ($focuseffect <= 0) return $result;

		if ($this->m_focus) {
			$result = $this->m_focus->getName();
			$result = $this->createSpellLink($focuseffect, $result, "");
		} else {
			$result = $focuseffect;
		}

		return $result;
	}

	function getProcText () {
		$result = "";

		$proceffect = $this->getField("proceffect");
		if ($proceffect <= 0) return $result;

		if ($this->m_proc) {
			$result = $this->m_proc->getName();
			$result = $this->createSpellLink($proceffect, $result, " (Combat)");
		} else {
			$result = $proceffect;
		}

		return $result;
	}

	function getWornText () {
		$result = "";

		$worneffect = $this->getField("worneffect");
		if ($worneffect <= 0) return $result;

		if ($this->m_worn) {
			$result = $this->m_worn->getName();
			$result = $this->createSpellLink($worneffect, $result, " (Worn)");
		} else {
			$result = $worneffect;
		}

		return $result;
	}

	function getScrollText () {
		$result = "";

		$scrolleffect = $this->getField("scrolleffect");
		if ($scrolleffect <= 0) return $result;

		if ($this->m_scroll) {
			$result = $this->m_scroll->getName();
			$result = $this->createSpellLink($scrolleffect, $result, "");
		} else {
			$result = $scrolleffect;
		}

		return $result;
	}

	function getFoodDrinkText() {
		return "This is a ". $this->getFoodDuration() ."!";
	}

	function getModsText () {
		$result = "";

		return $this->getModsTextArray();
	
		$result .= $this->formatStatString("Combat Effects: ", 	$this->getCombatEffects(), " ");
		$result .= $this->formatStatString("Strikethrough: ", 	$this->getStrikethrough(), "% ");
		$result .= $this->formatStatString("Shielding: ", 	$this->getShielding(), "% ");
		$result .= $this->formatStatString("Spell Shield: ", 	$this->getSpellShield(), "% ");
		$result .= $this->formatStatString("Avoidance: ", 	$this->getAvoidance(), " ");
		$result .= $this->formatStatString("Accuracy: ", 	$this->getAccuracy(), " ");
		$result .= $this->formatStatString("Stun Resist: ", 	$this->getStunResist(), "% ");

		return $result;
	}

	function getModsTextArray () {
		global $item_mod_fields;

		$result = "";

		foreach ($item_mod_fields as $name => $field) {
			$value  = $this->getField($field);
			$footer = ' ';
			$realname = $name;

			if ($name[0] == '%') {
				$footer   = '% ';
				$realname = substr($name, 1);
			}
			

			if ($value > 0) {
				$result .= $realname . ": +" . $value . $footer;
			}
			else if ($value < 0) {
				$result .= $realname . ": " . $value . $footer;
			}
		}

		return $result;
	}

	function getBardText () {
		return $this->getBardType() .": ". ($this->getBardValue() * 10);
	}

		/* Returns the hex-code of an item's color */
	function getHexColor () {
		$color = intval(fmod(floatval($this->getField("color")), 16777216)) & 0xffffff;
		return sprintf("#%06X", $color);
	}

	function getFoodDuration () {
		$casttime = $this->getField("casttime");
		$itemtype = $this->getField("itemtype");
		$duration = "";

			# 15 - drink, 14 - food
		if ($itemtype == 14) {
			if ($casttime > 60)
				$duration = "miraculous meal";
			else if ($casttime > 50)
				$duration = "enduring meal";
			else if ($casttime > 40)
				$duration = "feast";
			else if ($casttime > 30)
				$duration = "banquet sized meal";
			else if ($casttime > 20)
				$duration = "hearty meal";
			else if ($casttime > 5)
				$duration = "meal";
			else
				$duration = "snack";
		}
		else {
			if ($casttime > 60)
				$duration = "miraculous drink";
			else if ($casttime > 50)
				$duration = "enduring drink";
			else if ($casttime > 40)
				$duration = "flowing drink";
			else if ($casttime > 30)
				$duration = "lasting drink";
			else if ($casttime > 20)
				$duration = "refreshing drink";
			else if ($casttime > 5)
				$duration = "drink";
			else
				$duration = "whistle wetter";
		}

		return $duration;
	}

	function getAppearance () {
		global $armor_material;

		$material = $this->getField("material");

		if (isset($armor_material[$material])) return $armor_material[$material];
		return $material;
	}
	
	function getFlagText () {
		$flags = "";

		if ($this->isMagic()) 		$flags .= "MAGIC ITEM ";
		if ($this->isLore()) 		$flags .= "LORE ITEM ";
		if ($this->isPendingLore())	$flags .= "PENDING LORE ";
		if ($this->isArtifact())	$flags .= "ARTIFACT ";
		if ($this->isSummoned())	$flags .= "SUMMONED ";
		if ($this->isNoDrop())		$flags .= "NO TRADE ";
		if ($this->isNoTransfer())	$flags .= "NO TRANSFER ";
		if ($this->isAttuneable())	$flags .= "ATTUNEABLE ";
		if ($this->isNoRent())		$flags .= "TEMPORARY ";
		if ($this->isNoPet())		$flags .= "NO PET ";
		if ($this->isAugment())		$flags .= "AUGMENTATION ";

		return ($flags);
	}

		/* Return a string of the item stats: Str, Dex, Agi, HP, Mana, etc... */
	function getStatText () {
		$result = "";

		$result .= $this->formatStatString2("STR: ", $this->getStrength(), $this->getHeroicStr(), " ");
		$result .= $this->formatStatString2("DEX: ", $this->getDexterity(), $this->getHeroicDex(), " ");
		$result .= $this->formatStatString2("STA: ", $this->getStamina(), $this->getHeroicSta(), " ");
		$result .= $this->formatStatString2("CHA: ", $this->getCharisma(), $this->getHeroicCha(), " ");
		$result .= $this->formatStatString2("WIS: ", $this->getWisdom(), $this->getHeroicWis(), " ");
		$result .= $this->formatStatString2("INT: ", $this->getIntelligence(), $this->getHeroicInt(), " ");
		$result .= $this->formatStatString2("AGI: ", $this->getAgility(), $this->getHeroicAgi(), " ");
		$result .= $this->formatStatString("HP: ", $this->getHP(), " ");
		$result .= $this->formatStatString("MANA: ", $this->getMana(), " ");
		$result .= $this->formatStatString("ENDUR: ", $this->getEndurance(), " ");

		return ($result);
	}

		/* Return a string of the item resists */
	function getResistText () {
		$result = "";

		$result .= $this->formatStatString("SV FIRE: ",    $this->getFireResist(), " ");
		$result .= $this->formatStatString("SV DISEASE: ", $this->getDiseaseResist(), " ");
		$result .= $this->formatStatString("SV COLD: ",    $this->getColdResist(), " ");
		$result .= $this->formatStatString("SV MAGIC: ",   $this->getMagicResist(), " ");
		$result .= $this->formatStatString("SV POISON: ",  $this->getPoisonResist(), " ");
		$result .= $this->formatStatString("SV CORRUPT: ", $this->getCorruptResist(), " ");

		return ($result);
	}

	function getClassText () {
		global $class_list;
		$class = $this->getField("classes");

		if ($class == 0)     return ("None");
		if ($class == 65535) return ("ALL");	/* Shortcut, needs to be changed if a new class is added */
		$result = "";

		foreach ($class_list as $key => $value) {
			$class & $key && $result .= $value. " ";;
		}

		if ($class == (2 * $key - 1)) return ("ALL");
		return $result;
	}

	function getRaceText () {
		global $race_list;
		$race = $this->getField("races");

		if ($race == 0)     return ("None");
		if ($race == 65535) return ("ALL");	/* Shortcut, needs to be changed if a new race is added */
		$result = "";

		foreach ($race_list as $key => $value) {
			$race & $key && $result .= $value. " ";;
		}

		if ($race == (2 * $key - 1)) return ("ALL");
		return $result;
	}

	function getDeityText () {
		global $deity_list;
		$deity = $this->getField("deity");
		$result = "";

		foreach ($deity_list as $key => $value) {
			$deity & $key && $result .= $value . " ";;
		}

		return $result;
	}

		/* Returns a list of the item slots */
	function getSlotText () {
		return getEqItemSlot($this->getField("slots"));
	}

		/* Same as above but with abbreviated texts */
	function getShortSlotText () {
		return getEqItemSlotShort($this->getField("slots"));
	}


		/* Item property accessors */
	function getID () 			{ return $this->getField("id"); }
	function getName () 			{ return $this->getField("name"); }
	function getLore () 			{ return $this->getField("lore"); }
	function getDamage () 			{ return intval($this->getField("damage")); }
	function getDelay () 			{ return intval($this->getField("delay")); }
	function getLoreGroup () 		{ return $this->getField("loregroup"); }
	function getAC ()			{ return intval($this->getField("ac")); }
	function getAttack ()			{ return intval($this->getField("attack")); }
	function getRegen ()			{ return intval($this->getField("regen")); }
	function getManaRegen ()		{ return intval($this->getField("manaregen")); }
	function getEnduranceRegen ()		{ return intval($this->getField("enduranceregen")); }
	function getHaste ()			{ return intval($this->getField("haste")); }
	function getDamageShield ()		{ return intval($this->getField("damageshield")); }
	function getCombatEffects ()		{ return intval($this->getField("combateffects")); }
	function getShielding ()		{ return intval($this->getField("shielding")); }
	function getStunResist ()		{ return intval($this->getField("stunresist")); }
	function getStrikethrough ()		{ return intval($this->getField("strikethrough")); }
	function getSpellshield ()		{ return intval($this->getField("spellshield")); }
	function getAvoidance ()		{ return intval($this->getField("avoidance")); }
	function getAccuracy ()			{ return intval($this->getField("accuracy")); }
	function getDotShielding ()		{ return intval($this->getField("dotshielding")); }
	function getRequiredLevel ()		{ return intval($this->getField("reqlevel")); }
	function getRecommendedLevel ()		{ return intval($this->getField("reclevel")); }
	function getRecommendedSkill ()		{ return intval($this->getField("recskill")); }
	function getPowerSourceCapacity()	{ return intval($this->getField("unk193")); }
	function getPurity ()			{ return intval($this->getField("purity")); }
	function getElementalDmg ()		{ return intval($this->getField("elemdmgamt")); }
	function getExtraDmgAmt ()		{ return intval($this->getField("extradmgamt")); }
	function getVendorPrice ()		{ return intval($this->getField("price")); }
	function getSellRate ()			{ return intval($this->getField("sellrate")); }
	function getVendorPriceText() 		{ return formatPrice($this->getVendorPrice()); }
	function getTribute ()			{ return intval($this->getField("favor")); }
	function getStackSize ()		{ return intval($this->getField("stacksize")); }
	function getProcRate ()			{ return intval($this->getField("procrate")); }

	function getStackSizeText () {
		$stacksize = $this->getStackSize();
		if ($stacksize <= 1) return ("Not Stackable");
		return $stacksize;
	}
 
		/* Item stats */
	function getStrength () 		{ return $this->getField("astr"); }
	function getDexterity () 		{ return $this->getField("adex"); }
	function getStamina () 			{ return $this->getField("asta"); }
	function getWisdom () 			{ return $this->getField("awis"); }
	function getIntelligence () 		{ return $this->getField("aint"); }
	function getAgility () 			{ return $this->getField("aagi"); }
	function getCharisma () 		{ return $this->getField("acha"); }
	function getHP () 			{ return $this->getField("hp"); }
	function getMana ()	 		{ return $this->getField("mana"); }
	function getEndurance () 		{ return $this->getField("endur"); }
	function getHeroicStr ()		{ return $this->getField("heroic_str"); }
	function getHeroicSta ()		{ return $this->getField("heroic_sta"); }
	function getHeroicDex ()		{ return $this->getField("heroic_dex"); }
	function getHeroicAgi ()		{ return $this->getField("heroic_agi"); }
	function getHeroicWis ()		{ return $this->getField("heroic_wis"); }
	function getHeroicInt ()		{ return $this->getField("heroic_int"); }
	function getHeroicCha ()		{ return $this->getField("heroic_cha"); }
	function getDSMit ()			{ return $this->getField("dsmitigation"); }
	function getHealAmount ()		{ return $this->getField("healamt"); }
	function getSpellDmg ()			{ return $this->getField("spelldmg"); }
	function getClairvoyance ()		{ return $this->getField("clairvoyance"); }
	function getBackstabDmg ()		{ return $this->getField("backstabdmg"); }
	function getEvolvingLevel ()		{ return $this->getField("evolvinglevel"); }

	function getFireResist ()		{ return $this->getField("fr"); }
	function getDiseaseResist ()		{ return $this->getField("dr"); }
	function getColdResist ()		{ return $this->getField("cr"); }
	function getMagicResist ()		{ return $this->getField("mr"); }
	function getPoisonResist ()		{ return $this->getField("pr"); }
	function getCorruptResist ()		{ return $this->getField("svcorruption"); }
	function getRaces ()			{ return $this->getField("races"); }
	function getClasses ()			{ return $this->getField("classes"); }
	function getDeities ()			{ return $this->getField("deity"); }
	function getCharges ()			{ return intval($this->getField("maxcharges")); }
	function getSkillModValue ()		{ return intval($this->getField("skillmodvalue")); }

	function getAugSlot1Type ()		{ return intval($this->getField("augslot1type")); }
	function getAugSlot2Type ()		{ return intval($this->getField("augslot2type")); }
	function getAugSlot3Type ()		{ return intval($this->getField("augslot3type")); }
	function getAugSlot4Type ()		{ return intval($this->getField("augslot4type")); }
	function getAugSlot5Type ()		{ return intval($this->getField("augslot5type")); }

	function hasAugSlot1 ()			{ return intval($this->getField("augslot1visible")) != 0; }
	function hasAugSlot2 ()			{ return intval($this->getField("augslot2visible")) != 0; }
	function hasAugSlot3 ()			{ return intval($this->getField("augslot3ivisible")) != 0; }
	function hasAugSlot4 ()			{ return intval($this->getField("augslot4visible")) != 0; }
	function hasAugSlot5 ()			{ return intval($this->getField("augslot5visible")) != 0; }

	function getBagWr ()			{ return intval($this->getField("bagwr")); }
	function getBagSlots ()			{ return intval($this->getField("bagslots")); }
	function getRange ()			{ return intval($this->getField("range")); }
	function getLdonPrice ()		{ return intval($this->getField("ldonprice")); }

		/* Item property checks */
	function isMagic ()			{ return ($this->getField("magic") 	 	!= 0); }
	function isLore ()			{ return ($this->getField("loregroup")       	!= 0); }
	function isPendingLore ()		{ return ($this->getField("pendingloreflag") 	!= 0); }
	function isNoDrop ()			{ return ($this->getField("nodrop")     	== 0); }
	function isNoTransfer ()		{ return ($this->getField("notransfer") 	!= 0); }
	function isNoPet ()			{ return ($this->getField("nopet")      	!= 0); }
	function isAttuneable ()		{ return ($this->getField("attuneable") 	== 1); }
	function isArtifact ()			{ return ($this->getField("artifactflag") 	== 1); }
	function isSummoned ()			{ return ($this->getField("summonedflag") 	== 1); }
	function isNoRent ()			{ return ($this->getField("norent") 		== 0); }
	function isAugment ()			{ return ($this->getField("itemtype") 		== 54); }
	function isArrow ()			{ return ($this->getField("itemtype")	 	== 27); }
	function isSpellScroll ()		{ return ($this->getField("itemtype")	 	== 20); }
	function isContainer ()			{ return ($this->getField("itemclass")		== 1); }
	function isFood ()			{ return ($this->getField("itemtype")	 	== 15); }
	function isDrink ()			{ return ($this->getField("itemtype")	 	== 14); }
	function isInstrument ()		{ return ($this->getField("bardtype")	 	!= 0); }
	function isTradeskill ()		{ return ($this->getField("tradeskills") 	!= 0); }
	function isPotionBelt ()		{ return ($this->getField("potionbelt") 	!= 0); }
	function isPowerSource ()		{ return ($this->getPowerSourceCapacity() 	> 0); }

	function hasSlots ()           	 	{ return ($this->getField("slots")	 	!= 0); }
	function hasLoreGroup ()		{ return ($this->getField("loregroup") 		> 0); }
	function hasRecommendedSkill ()		{ return ($this->getRecommendedSkill() 		> 0); }
	function hasFactionMod ()		{ return ($this->getField("factionmod1") 	!= 0); }

	function hasSkillMod ()	{
		$skillmodtype  = $this->getField("skillmodtype");
		$skillmodvalue = $this->getField("skillmodvalue");
		return ($skillmodtype > 0 && $skillmodvalue > 0);
	}

	function getIconFilename($extension) {
		return "item_".$this->getField('icon').".".$extension;
	}

	function getItemType ()	{
		return getEqItemType($this->getField("itemtype"), $this->getField("itemclass"));
	}

	function getExtraDmgSkill () {
		global $skills;

		$extradmgskill = $this->getField("extradmgskill");

		if (isset($skills[$extradmgskill])) return $skills[$extradmgskill];
		return $extradmgskill;
	}

	function getBaneDmg () {
		$banedmgamt = $this->getField("banedmgamt");
		$banedmgraceamt = $this->getField("banedmgraceamt");

		if ($banedmgamt > $banedmgraceamt) return intval($banedmgamt);
		return intval($banedmgraceamt);
	}

	function getBaneType () {
		global $bodytypes_table;
		global $races_table;

		$banedmgbody = $this->getField("banedmgbody");
		$banedmgrace = $this->getField("banedmgrace");
		$bane = "";

		if ($banedmgbody > 0) {
			if (isset($bodytypes_table[$banedmgbody]))
				$bane = $bodytypes_table[$banedmgbody];
			else
				$bane = "UNKNOWN BODYTYPE";
		}

		if ($banedmgbody > 0 && $banedmgrace > 0) $bane .= ", ";
		if ($banedmgrace > 0) $bane = $this->getRaceName($banedmgrace);

		return $bane;
	}

	function getLdonTheme () {
		global $ldon_themes;

		$ldontheme = $this->getField("ldontheme");
		$themes = array();

		foreach ($ldon_themes as $key => $value) {
			$ldontheme & $key && $themes[] = $value;
		}

		$themes == (2 * $key - 1) && $themes = array("ALL");
		$themes == 0              && $themes = array("None");

		return $themes;
	}

	function getBagSize () {
		global $sizes;
		$bagsize = $this->getField("bagsize");
		return $sizes[$bagsize];
	}

	function getAugSolvent () {
		$solvent = $this->getField("augdistiller");
		$solvname = $this->getItemName($solvent);
		return $solvname;
	}

	function getAugType () {
		$augtype = $this->getField("augtype");
		if ($augtype == 2147483647) return "Fits in all slot types.";

		$types = array();
		for ($i = 0; $i < 0x1f; $i++)
			if ($augtype & (1 << $i))
				$types[] = $i + 1;

		return join(", ", $types);
	}

	function getAugRestriction () {
		global $aug_restrictions;
		$augrestrict = $this->getField("augrestrict");
		$restrict = "";

		if ($augrestrict > 0) $restrict = $augrestrict;
		if (isset($aug_restrictions[$augrestrict])) $restrict = $aug_restrictions[$augrestrict];
		return $restrict;
	}

	function getBardValue () {
		$bardvalue = $this->getField("bardvalue");
		return sprintf("%1.1f", $bardvalue / 10);
	}

	function getBardType ()	{
		global $item_types;
		$bardtype = $this->getField("bardtype");

		if (isset($item_types[$bardtype])) return $item_types[$bardtype];
		return $bardtype;
	}

	function getSkillModType () {
		global $skills;
		$skillmodtype = $this->getField("skillmodtype");

		if (isset($skills[$skillmodtype])) return $skills[$skillmodtype];
		return $skillmodtype;
	}


	function getWeight ()			{
		$weight = $this->getField("weight");
		$weight = sprintf("%3.1f", $weight/10);
		return $weight;
	}

	function getSize () {
		global $sizes;
		$size = $this->getField("size");
		return $sizes[$size];
	}

	function getElementalType() { 
		global $element_type;

		$elemdmgtype = $this->getField("elemdmgtype");

		if (isset($element_type[$elemdmgtype])) return $element_type[$elemdmgtype];
		return "";
	}

	function isEvolving () {
		$loregroup = $this->getField("loregroup");
		return ($loregroup > 1000 && $loregroup < 90000);
	}

	function isWeapon () {
		$damage = $this->getDamage();
		$delay  = $this->getDelay();
		return ($damage > 0 && $delay > 0);
	}

	function isFoodDrink () {
		$itemtype = $this->getField("itemtype");
		return ($itemtype == 15 || itemtype == 14);
	}

	function isLdon () {
		$theme = $this->getField("ldontheme");
		$price = $this->getField("ldonprice");
		return ($theme > 0 || $price > 0);
	}

	function isVisible () {
		$slots = $this->getField("slots");
		return (($slots & 923268) != 0);	/* TODO: Need explanation */
	}


	function isExpendable () {
		$clicktype = $this->getField("clicktype");
		$itemtype  = $this->getField("itemtype");
		return ($clicktype == 3 || $itemtype == 21);
	}

	function hasCharges () {
		$charges     = $this->getField("maxcharges");
		$clickeffect = $this->getField("clickeffect");
		return ($charges > 0 && $clickeffect > 0);
	}

	function isStackable ()	{ 
		$itemtype = $this->getField("itemtype");

		return ($itemtype == 0x0e || $itemtype == 0x0f || $itemtype == 0x11 ||
			$itemtype == 0x12 || $itemtype == 0x13 || $itemtype == 0x1b ||
			$itemtype == 0x1c || $itemtype == 0x25 || $itemtype == 0x26 ||
			$itemtype == 0x37 || $itemtype == 0x38);
	}

	function getLoregroupText () {
		$name = "UNKNOWN LOREGROUP";
		$loregroup = $this->getLoreGroup();

		if ($loregroup <= 0) return $name;

		$name = getDbstr($loregroup, 7);
		return $name;
	}

	function getEvolvingText () {
		$result  = sprintf("Evolving: Level %d/%d %d%%", 0, 0, 0);
		return $result;
	}

	function getItemName($id) {
		$name = "";
		if ($id <= 0) return $name;
		$name = "Unknown Item #". $id;

		$query = "SELECT name FROM eqitems WHERE id=". $id;

		$result = mysql_query($query);

		if ($result) {
			$row = mysql_fetch_row($result);
			if ($row) $name = $row[0];
		}

		return $name;
	}

	function formatStatString($header, $value, $footer) {
		if ($value > 0)
			return $header . "+" . $value .$footer;
		else if ($value < 0)
			return $header . $value . $footer;
	}

	function formatStatString2($header, $value1, $value2, $footer) {
		$result = "";

		if ($value1 > 0) 
			$result = $header . "+" . $value1;
		else if ($value1 < 0)
			$result = $header . $value1;
		else if ($value1 == 0 && $value2 != 0)
			$result = $header . "+" . $value1;

		if ($value2 > 0)
			$result .= "+" . $value2 . $footer;
		else if ($value2 < 0)
			$result .= $value2 . $footer;
		else if ($value1 != 0)
			$result .= $footer;

		return $result;
	}

	function formatStatStringPos($header, $value, $footer) {
		if ($value > 0)
			return $header . $value .$footer;
	}

}
?>
