<?php

/*

*/

include("common.inc");
include("spell_fields.inc");
include("dbstr.php");

function loadEqSpell($id) {
	global $spell_fields;

	if ($id == null || $id == "") return null;
	$query = "SELECT ". implode(", ",$spell_fields) ." FROM eqspells WHERE (id=".$id.");";

	$result = mysql_query($query);
	if (!$result) return null;

	$row = mysql_fetch_row($result);
	if (count($row) <= 1) return null;

	$spell = new EqSpell;
	$spell->fromArray($row);
	return $spell;
}


class EqSpell {

	var $DATA_SIZE  = 40;
        var $VALID_DATA = true;
	var $m_data     = array();
	var $m_isset    = false;

		/* Spell effects */
	var $m_effect = null;
	var $m_worn   = null;
	var $m_focus  = null;
	var $m_proc   = null;
	var $m_scroll = null;

		/* Constructor */
	function EqItem () {
	}

		/* Initialize the spell objects */
	function initSpells () {
	}

		/* Loads the item data from an array */
	function fromArray ($fields) {
		global $spell_fields;

		if (count($fields) < $this->DATA_SIZE) {
			die("Error: spell has ". count($fields) ." fields");
			$this->VALID_DATA = false;
		}

		for ($i = 0; $i < $this->DATA_SIZE; $i++) {
			$this->m_data[$spell_fields[$i]] = $fields[$i];	
		}

		$this->m_isset = true;
	}
	

		/* Access a spell field */
	function getField ($field) {
		if (isset($this->m_data[$field])) {
			return $this->m_data[$field];
		}
		else {
			return 0;
		}
	}

		/* Access an HTML string to display the spell */
	function getHtmlDisplayString () {
		$result = "";

		$result .= $this->getName() . "<br / >\n";
		$result .= $this->getFullDescription("", "<br / >\n");

		return $result;
	}

	function isDiscipline() {
		$skill = $this->getField("skill");

			# Abjuration, Alteration, Conjuration, Divination, Evocation
		if ($skill == 4 || $skill == 5 || $skill == 14 || $skill == 18 || $skill == 24)
			return false;
		else
			return true;
	}

		/* Property accessors */
	function getID () 	{ return $this->getField("id"); }
	function getName () 	{ return $this->getField("name"); }
	function getMana () 	{ return $this->getField("manacost"); }
	function getClasses ()  { return $this->getField("classes"); }

	function getSkillName () {
		global $skills;

		$skill = $this->getField("skill");
		if (isset($skills[$skill])) return $skills[$skill];
		return $skill;
	}

	function getDescription() {
		$description = "";

		$descnum = $this->getField("descnum");
		$description = getDbstr($descnum, 6);

		if ($description != "") {

			for ($i = 12; $i > 0; $i--) {
				$base = $this->getField("base". $i);
				$max = $this->getField("max". $i);

				$atnum = (abs($base) > abs($max)) ? abs($base) : abs($max);

					// parse out #1, #2, etc
				$description = str_replace("#". $i, abs($base),	$description);
				$description = str_replace("#". dechex($i), abs($base),	$description);
				$description = str_replace("#". strtoupper(dechex($i)), abs($base), $description);

					// parse out @1, @2, etc
				$description = str_replace("@". $i, abs($max), $description);
				$description = str_replace("@". dechex($i), abs($max), $description);
				$description = str_replace("@". strtoupper(dechex($i)), $atnum, $description);
			}

				// parse out %z (duration)
			$duration = $this->getField("duration");
			$duration_hour = floor($duration / 10 / 60);
			$duration_minute = $duration / 10 % 60;
			$duration_second = $duration % 10 * 6;
			$duration = sprintf("%0d:%02d:%02d", $duration_hour, $duration_minute, $duration_second);
			$description = str_replace("%z", $duration, $description);

				// parse out %x (also duration)
			$description = str_replace("%x", $duration, $description);
		}

		return $description;
	}

	function getFullDescription ($header, $footer) 	{ 
		$result = "";

		$temp = $this->getField("desc1"); 
		if ($temp != "") $result .= $header . "1: " . $temp . $footer;

		$temp = $this->getField("desc2"); 
		if ($temp != "") $result .= $header . "2: " . $temp . $footer;

		$temp = $this->getField("desc3"); 
		if ($temp != "") $result .= $header . "3: " . $temp . $footer;

		$temp = $this->getField("desc4"); 
		if ($temp != "") $result .= $header . "4: " . $temp . $footer;

		$temp = $this->getField("desc5"); 
		if ($temp != "") $result .= $header . "5: " . $temp . $footer;

		$temp = $this->getField("desc6"); 
		if ($temp != "") $result .= $header . "6: " . $temp . $footer;

		$temp = $this->getField("desc7"); 
		if ($temp != "") $result .= $header . "7: " . $temp . $footer;

		$temp = $this->getField("desc8"); 
		if ($temp != "") $result .= $header . "8: " . $temp . $footer;

		$temp = $this->getField("desc9"); 
		if ($temp != "") $result .= $header . "9: " . $temp . $footer;

		$temp = $this->getField("desc10"); 
		if ($temp != "") $result .= $header . "10: " . $temp . $footer;

		$temp = $this->getField("desc11"); 
		if ($temp != "") $result .= $header . "11: " . $temp . $footer;

		$temp = $this->getField("desc12"); 
		if ($temp != "") $result .= $header . "12: " . $temp . $footer;

		return $result;
	}



}
?>
